require "test_helper"

describe "hex" do

  it "should accept different hex codes" do
    Piccolor.to_human("#ff0000").must_equal "red"
    Piccolor.to_human("#f00").must_equal "red"
    Piccolor.to_human("ff0000").must_equal "red"
  end

  it "should convert whites, greys and blacks" do
    colors = {
      "#ffffff" => "white",
      "#eeeeee" => "white",
      "#ededed" => "light grey",
      "#cccccc" => "light grey",
      "#c1c1c1" => "grey",
      "#999999" => "grey",
      "#888888" => "grey",
      "#777777" => "grey",
      "#666666" => "grey",
      "#555555" => "dark grey",
      "#444444" => "dark grey",
      "#333333" => "dark grey",
      "#222222" => "dark grey",
      "#111111" => "black",
      "#000000" => "black"
    }
    colors.each do |hex, value|
      Piccolor.to_human(hex).must_equal value
    end
  end

  it "should convert warm and cold greys" do
    colors = {
      "#e2d3d3" => "warm grey",
      "#e2dcd3" => "warm grey",
      "#bcbcaf" => "warm grey",
      "#9e9e91" => "warm grey",
      "#b9c0cb" => "cold grey",
      "#b9cbbe" => "cold grey"
    }
    colors.each do |hex, value|
      Piccolor.to_human(hex).must_equal value
    end
  end


  it "should convert colors" do
    colors = {
      "#00ff00" => "green",
      "#0000ff" => "blue",
      "#e80000" => "red",
      "#0a4a00" => "green",
      "#730000" => "red",
      "#ffae00" => "orange",
      "#030010" => "black",
      "#402304" => "brown",
      "#9febf0" => "light blue",
      "#eb9494" => "pink",
      "#666a36" => "brown",
      "#5c2b5d" => "purple",
      "#070123" => "black",
      "#043d3c" => "teal",
      "#c4bab5" => "warm grey",
      "#ece8e0" => "warm grey"
    }

    colors.each do |hex, value|
      Piccolor.to_human(hex).must_equal value
    end
  end

  it "should convert doubles" do
    colors = {
      "#091e3a" => "dark blue",
      "#063b52" => "blue",
      "#376ab0" => "blue",
      "#256b85" => "blue",
      "#127a9d" => "blue",
      "#8a8988" => "grey",
      "#c0e7f1" => "light blue",
      "#4ab9d8" => "light blue",
      "#77b0c4" => "light blue",
      "#5399f2" => "blue",
      "#85ade8" => "light blue",
      "#a3b6d7" => "light blue",
      "#dde5f5" => "light blue",
      "#f5f4f5" => "white"
    }
    colors.each do |hex, value|
      Piccolor.to_human(hex).must_equal value
    end
  end

end
